/**********************************************************************************
* Blueprint Reality Inc. CONFIDENTIAL
* 2020 Blueprint Reality Inc.
* All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains, the property of
* Blueprint Reality Inc. and its suppliers, if any.  The intellectual and
* technical concepts contained herein are proprietary to Blueprint Reality Inc.
* and its suppliers and may be covered by Patents, pending patents, and are
* protected by trade secret or copyright law.
*
* Dissemination of this information or reproduction of this material is strictly
* forbidden unless prior written permission is obtained from Blueprint Reality Inc.
***********************************************************************************/

#pragma once

#include "CoreMinimal.h"
#include "Engine/EngineTypes.h"
#include "Components/StaticMeshComponent.h"
#include "Materials/MaterialInstanceDynamic.h"

#include "Transmission/Generated/VirtualCamera_types.h"
#include "Transmission/SharedTextures/SharedTextureReceiver.h"

#include "ForegroundCutoffMeshComponent.generated.h"

using namespace mixcast::data;
using namespace mixcast::thrift;

class AExpCamera;

UCLASS(HideCategories = ("Rendering", "Tags", "Activation", "Cooking", "Physics", "LOD", "Collision"))
class MIXCAST_API UForegroundCutoffMeshComponent : public UStaticMeshComponent
{
	GENERATED_BODY()
	
public:
	static TArray<UForegroundCutoffMeshComponent*> Active;

	UForegroundCutoffMeshComponent();

	void AttachToCamera(AExpCamera* camera);

	void Update(VirtualCamera* camInfo);

protected:
	virtual void BeginPlay() override;
	virtual void EndPlay(const EEndPlayReason::Type EndPlayReason) override;

private:
	float nearPlane;
	SharedTextureReceiver* FgCutoffReceiver;
	UMaterialInstanceDynamic* ApplyDepthCutoffMat;

	FDelegateHandle TexChangedDelegate;

	void HandleTextureChanged();
};
