/**********************************************************************************
* Blueprint Reality Inc. CONFIDENTIAL
* 2020 Blueprint Reality Inc.
* All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains, the property of
* Blueprint Reality Inc. and its suppliers, if any.  The intellectual and
* technical concepts contained herein are proprietary to Blueprint Reality Inc.
* and its suppliers and may be covered by Patents, pending patents, and are
* protected by trade secret or copyright law.
*
* Dissemination of this information or reproduction of this material is strictly
* forbidden unless prior written permission is obtained from Blueprint Reality Inc.
***********************************************************************************/

#pragma once

#include <string>

#include "CoreMinimal.h"
#include "Engine/Engine.h"
#include "IHeadMountedDisplay.h"
#include "Runtime/Launch/Resources/Version.h"

#include "Utility/MathUtil.hpp"
#include "MixCastSdkActor.h"


#if ENGINE_MAJOR_VERSION == 4 && ENGINE_MINOR_VERSION >= 18
#include "IXRTrackingSystem.h"
#endif

class TrackingUtil
{
public:
	static bool IsPlatformSteamVR(void)
	{
#if ENGINE_MAJOR_VERSION == 4 && ENGINE_MINOR_VERSION >= 18
		if (!GEngine || !GEngine->XRSystem.IsValid())
			return false;

		return GEngine->XRSystem->GetSystemName().IsEqual(TEXT("SteamVR"));
#else
		if (!GEngine || !GEngine->HMDDevice.IsValid())
			return false;

		return GEngine->HMDDevice->GetHMDDeviceType() == EHMDDeviceType::DT_SteamVR;
#endif
	};
	static bool IsPlatformOculus(void)
	{
#if ENGINE_MAJOR_VERSION == 4 && ENGINE_MINOR_VERSION >= 18
		if (!GEngine || !GEngine->XRSystem.IsValid())
			return false;

		return GEngine->XRSystem->GetSystemName().IsEqual(TEXT("OculusHMD"));
#else
		if (!GEngine || !GEngine->HMDDevice.IsValid())
			return false;

		return GEngine->HMDDevice->GetHMDDeviceType() == EHMDDeviceType::DT_OculusRift;
#endif
	};
};
